<?php
/**
 * FeedGeorge main class
 * 
 * @package FeedGeorge_Wordpress_PLUGIN
 * @author CH Foo
 * @copyright 2011 FeedGeorge.com
 * @access public
 */
 
class WP_FG_Ajax {
    private $apikey;
    private $apiurl;
    
    function __construct() {
        $this->apiurl = FG_SITE . 'api/source.json?';
    }
    
    function call_ajax() {
        $ne = trim($_REQUEST['ne']);
        $sw = trim($_REQUEST['sw']);
        $cat = trim($_REQUEST['c']);
        
        if (preg_match('/^[0-9,.]+$/',$ne) && preg_match('/^[0-9,.]+$/',$sw)) {
            
            if (empty($cat)) $cat = '1,2,7,32,37,3,4,5,25,33,34,9,10,11,13,14,15,16,17,18,19,20,21,22,23,24,27,31,35,36,29,38,30,28,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53';
            
            $r = json_decode($this->post_request($ne,$sw,$cat),true);
			
            if (isset($r) && !isset($r['error'])) {
                
                $this->print_output(json_encode($r));
            }
            else
                $this->print_output(json_encode('-1'));
        }
        else {
            $this->print_output(json_encode('-1'));
        }
        exit;
    }
    
	
	function save_poly() {
	    
		$var = $_REQUEST['m'];
	    
		if (isset($var)) {
		  parse_str($var,$post );
		  
		  if ($this->write_post($post)>0) {
			$this->print_output(1);
		  }
		  else
			$this->print_output(-1);
		}
		else
			$this->print_output(-1);
			
		exit;
	}
	
	
	function write_post($post) {
        global $current_user;
		
		if (!current_user_can( 'edit_posts' ))  {
            return -1;
        }
		
		
		
        $user_id = $current_user->ID;
		
        $post_title = $post['ptitle'];
        $post_content = $post['pdesc'];
        $post_type = 'post';
		$post_kml = $post['fgkml'];
		//$post_kml = $this->generate_kml($post);
		$post_data = $_POST['p'];
		$post['fgkmlfile'] = $_POST['f'];
        $post_id = wp_insert_post( array( 'post_title' => $post_title, 'post_content'=>$post_content,'post_type' => $post_type, 'post_status' => 'publish' ) );
        if (!$post_id) {
            return -1;
        }
		
		if (isset($_FILES['fgkmlfile']) && is_uploaded_file($_FILES['fgkmlfile']['tmp_name'])) {
			$this->moveKmlFile($post_id,$_FILES['fgkmlfile'],$post_data);
		}
		else {
			add_post_meta($post_id, FGEORGE_KMLFILE, array('kml'=>$post_kml,'styles'=>$post_data['styles'],'points'=>$post_data['points']));
			$this->uploadkmlfile($post_id);
		}
        return $post_id;
    }
	
	
	function uploadkmlfile($post_id) {
		$uploads = wp_upload_dir();
		$kml = get_post_meta($post_id, FGEORGE_KMLFILE,true);
		
		if(!file_exists($uploads['basedir'] . FG_KML_DIR)) {
			mkdir($uploads['basedir'] . FG_KML_DIR);
		}
		
		$kmlfile = $uploads['basedir'] . FG_KML_DIR .'/wpfg_'. $post_id .'.kml';
		
		if($fs = fopen($kmlfile,'w')) {
			if(!fwrite($fs, trim($kml['kml'])))
				return false;
				
			fclose($fs);
			
			return true;
		}
		else
			return false;
		
	}
	
	
	function moveKmlFile($post_id,$FILE,$post_data) {
		
		$uploads = wp_upload_dir();
		
		if (is_uploaded_file($FILE['tmp_name'])) {
		   if(!file_exists($uploads['basedir'] . FG_KML_DIR)) {
			mkdir($uploads['basedir'] . FG_KML_DIR);
		   }
		
		   $kmlfile = $uploads['basedir'] . FG_KML_DIR .'/wpfg_'. $post_id .'.kml';
		   
		   $tmp_name = $FILE['tmp_name'];
		   $name = $FILE['name'];
           move_uploaded_file($tmp_name, $kmlfile);
		   $post_kml = file_get_contents($kmlfile); 
		   add_post_meta($post_id, FGEORGE_KMLFILE, array('kml'=>$post_kml,'styles'=>$post_data['styles'],'points'=>$post_data['points']));
		   
		}
	}
	
	function exportKMLFile() {
		header('Content-Type: application/vnd.google-earth.kml+xml kml; charset=utf8');
        header('Content-Disposition: attachment; filename="kmlfile.kml"');
        header('Cache-Control: no-cache, must-revalidate');
        //header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
		
		$kml = stripslashes(trim($_POST['fgkmlexport']));
		echo $kml;
		exit;
	}
	
	
	function readKMLFile() {
		if (isset($_FILES['fgkmlfile']) && is_uploaded_file($_FILES['fgkmlfile']['tmp_name'])) {
			//$_FILES['fgkmlfile']
			$tmp_name = $_FILES['fgkmlfile']['tmp_name'];
			
			$post_kml = file_get_contents($tmp_name);
			$this->print_output($post_kml);
		}
		
		
		exit;
	}
	
    
    function print_output($msg) {
        header('Content-Type: text/plain; charset=utf-8');
        echo $msg;
    }
    
    function post_request($ne,$sw,$cat) {
        global $fg_geo;
        
        $options = $fg_geo->get_options();
        $apikey = $options['feedgeorge_key'];
        if (!empty($apikey)) {
            $url_with_get = $this->apiurl .'ne='.$ne.'&sw='.$sw.'&sc='.$cat.'&s=&page=1&d=730&dt=undefined&df=undefined&sr=undefined&_=1294294811675&key=' . $apikey;
            $result = file_get_contents($url_with_get);
			
		/*	 $ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url_with_get);
		//curl_setopt($ch, CURLOPT_POSTFIELDS, $post_string);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		//curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		$result = curl_exec($ch);
		curl_close($ch);*/
		
			
        }
        return $result;
    }
	
	function generate_kml($post) {
	
	$post_data = $_POST['p'];
	$points = '';
	if (isset($post_data['points']) && count($post_data['points']) > 2) {
		for($i=0; $i<count($post_data['points']); $i++) {
			list($lat,$lng) = split(',',$post_data['points'][$i]);
			$points .=  $lng .','. $lat . ',0 ' . "\n";
		}
	}
	
$kml = '
<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://www.opengis.net/kml/2.2">
<Document>
<name><![CDATA[ '.$post['ptitle'].' ]]></name>
<description><![CDATA[ '.$post['pdesc'].' ]]></description>
'.$post_data['styles'].'
<Placemark>
	<name><![CDATA[ '.$post['ptitle'].' ]]></name>
	<description><![CDATA[ '.$post['pdesc'].' ]]></description>
	<styleUrl>#fgpolyStyle</styleUrl>
	<Polygon>
		<extrude>1</extrude>
		<altitudeMode>relativeToGround</altitudeMode>
		<outerBoundaryIs>
			<LinearRing>
				<coordinates>
				'.$points.'
				</coordinates>
			</LinearRing>
		</outerBoundaryIs>
	</Polygon>
</Placemark>
</Document>
</kml>
';

return $kml;
	
	}
    
}


?>