<?php
/**
 * @package FeedGeorge_Wordpress_PLUGIN
 * @version 2.1.0
 */
/*
Plugin Name: FeedGeorge Wordpress Plugin
Plugin URI: http://wordpress.feedgeorge.com/
Description: FeedGeorge Wordpress Plugin is  To help WordPress users with a better geotagging experience for can now geotag their blog posts with the plugin and at the same time aggregates all posts in a single map. Users can then choose if they want their posts to be discovered at Feed George map.
Author: C H Foo
Version: 2.1.1
Author URI: http://wordpress.feedgeorge.com/
*/

/*

Copyright (c) 2011-2012, C H Foo, Feedgeorge

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

define( 'FG_VERSION', '2.1.1' );

define( 'FG_DIR', dirname(__FILE__) );
define( 'FG_REL_URL', plugins_url( $path = '/' . basename( dirname( __FILE__ ) ) ) );
define( 'FG_THEMES_DIR', FG_DIR . '/themes' );
define( 'FG_INCLUDE_DIR', FG_DIR . '/includes' );
define( 'FG_JS_DIR', FG_DIR . '/js' );
define( 'FG_JS_URL', FG_REL_URL . '/js' );
define( 'FG_CSS_URL', FG_REL_URL . '/css' );
define( 'FG_IMG_URL', FG_REL_URL . '/images' );
define( 'FG_KML_DIR', '/WP-FeedGeorge' );
define( 'FG_NONCENAME', plugin_basename(__FILE__) );

define( 'FG_SITE', 'http://www.feedgeorge.com/');
define( 'FG_APISITE', 'http://www.feedgeorge.com/apisignup');

/* Default variable */
define('FGEORGE_GEOLOCATION', '_FGEORGE_GEOLOCATION');
define('FGEORGE_KMLFILE', '_FGEORGE_KMLFILE');

define('FG_MAP_HEIGHT', 300);
define('FG_MAP_ZOOM', 14);
define('FG_MAP_LAT', 3.14463);
define('FG_MAP_LNT',101.700439);
define('FG_MAP_MARKER', 'map-marker.png');
define('FG_MAP_SMALL_MARKER', 'map_small_marker.png');

define('FG_KEY01','da39a3ee5e6b4b0d3255bfef95601890afd80709');

global $fg_geo;
global $fg_admin;

require_once('includes/fg_category.php');
require_once('includes/classes.php');
require_once('includes/fg_admin.php');
require_once('includes/fg_widget.php');
require_once('includes/fg_feed.php');
require_once('includes/fg_ajax.php');
require_once('includes/function.php');


//Initialize the WordPress Controller and set it up.
$fg_ajax  = new WP_FG_Ajax();
$fg_geo   = new WP_FGgeo();
$fg_admin = new WP_FG_Admin();
$fg_feed  = new FG_Feed();



//Register the activation hook
register_activation_hook( __FILE__, Array( &$fg_geo , 'init_plugin' ) );

//Register the deactivation hook
register_deactivation_hook( __FILE__, Array( &$fg_geo , 'kill_plugin' ) );

?>
